#!/usr/bin/perl -w
#
# Externes Zeug einbinden
use strict;
use warnings;
use CGI;
use Fcntl ':flock'; # import LOCK_* constants
use Carp; # See http://perldoc.perl.org/Carp.html
# Constants
use constant	NO					=>	0;
use constant	YES					=>	1;
use constant	MAYBE				=>  2;
use constant	LINEWIDTH			=>	23;
use	constant	MAXJUMPS			=>	10;
use constant	DEBUGLOG			=>  0;

# Globals
my @map; #my @linetmp;
my $overalljumps=0;
my $overalldeadends=0;

# Zeile 1-23 (23!) Ursprung (0/0) ist links oben. Start war x=12 y=12 (11/11 wenn man bei 0/0) beginnt.
@map=(	'N','N','N','N','N','N','N','N','N','F','F','F','F','F','N','N','N','N','N','N','N','N','N',
		'N','N','N','N','N','N','F','F','F','F','4','7','7','F','F','F','F','N','N','N','N','N','N',
        'N','N','N','N','F','F','F','5','4','4','8','3','3','4','6','3','F','F','F','N','N','N','N',
        'N','N','N','F','F','1','4','5','1','1','1','4','5','1','7','1','3','5','F','F','N','N','N',
        'N','N','F','F','4','9','4','9','6','7','5','5','5','8','7','6','6','8','5','F','F','N','N',
        'N','N','F','3','7','2','9','8','3','5','6','7','3','9','1','8','7','5','8','5','F','N','N',
        'N','F','F','1','4','7','8','4','2','9','2','7','1','1','8','2','2','7','6','3','F','F','N',
		'N','F','7','2','1','8','5','5','3','1','1','3','1','3','3','4','2','8','6','1','3','F','N',
        'N','F','4','2','6','7','2','5','2','4','2','2','5','4','3','2','8','1','7','7','3','F','N',
        'F','F','4','1','6','5','1','1','1','9','1','4','3','4','4','3','1','9','8','3','7','F','F',
        'F','4','3','5','2','3','2','2','3','2','4','2','5','3','5','1','1','3','5','5','3','7','F',
        'F','2','7','1','5','1','1','3','1','5','3','3','2','4','2','3','7','7','5','4','2','7','F',
        'F','2','5','2','2','6','1','2','4','4','6','3','4','1','2','1','2','6','5','1','8','8','F',
        'F','F','4','3','7','5','1','9','3','4','4','5','2','9','4','1','9','5','7','4','8','F','F',
        'N','F','4','1','6','7','8','3','4','3','4','1','3','1','2','3','2','3','6','2','4','F','N',
        'N','F','7','3','2','6','1','5','3','9','2','3','2','1','5','7','5','8','9','5','4','F','N',
        'N','F','F','1','6','7','3','4','8','1','2','1','2','1','2','2','8','9','4','1','F','F','N',
        'N','N','F','2','5','4','7','8','7','5','6','1','3','5','7','8','7','2','9','3','F','N','N',
        'N','N','F','F','6','5','6','4','6','7','2','5','2','2','6','3','4','7','4','F','F','N','N',
        'N','N','N','F','F','2','3','1','2','3','3','3','2','1','3','2','1','1','F','F','N','N','N',
        'N','N','N','N','F','F','F','7','4','4','5','7','3','4','4','7','F','F','F','N','N','N','N',
        'N','N','N','N','N','N','F','F','F','F','3','3','4','F','F','F','F','N','N','N','N','N','N',
        'N','N','N','N','N','N','N','N','N','F','F','F','F','F','N','N','N','N','N','N','N','N','N');


# Ausgabe des ganzen
my $startx		=	11;
my $starty		=	11;
my $x;
my $y;
my $xmax		=	LINEWIDTH-1;
my $elements	=	($#map+1);
my $ymax		=	($elements/($xmax+1)-1);
printf ("Elements in map: $elements\n");
printf ("Size of map: $xmax+1 * $ymax+1\n");
printf ("Column : 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2\n");

#for ($y=0; $y <= 2; $y++)
for ($y=0; $y <= $ymax; $y++)
{
	printf("line %2s: ", $y);
	for ($x=0; $x <= $xmax; $x++)
	{
		printf("%s ", $map[ $y*($xmax+1) + $x]);
	}
	printf("\n");
}

#die;

# Nun mal los!
print("Starting at (x/y): $startx/$starty.\n");
jumpFromXY($startx, $starty, $startx, $starty, "", 0); #"(11/11)", 1);

# Diese Funktion macht den Absprung in alle Richtungen
sub jumpFromXY
{
	my $lx=shift;
	my $ly=shift;
	my $oldlx=shift;
	my $oldly=shift;
	my $lhistory=shift;
	my $ljumps=shift;
	$overalljumps++;

	####################################
	# Checken des jetzt erreichten Ziels

	# History fuehren
	$lhistory = $lhistory . "-" . "(" . $lx . "/" . $ly . ")"; # . "-";
	$ljumps++;

	# Checken, ob wir übers Ziel hinausschossen!
	if ($lx < 0 || $lx > $xmax || $ly < 0 || $ly > $ymax || $ljumps > MAXJUMPS)
	{
		$overalldeadends++;
		if (DEBUGLOG) { printf("Dead end # %s. History: %s, Jumps # %s, Location: (%s/%s)\n", $overalldeadends, $lhistory, $ljumps, $lx, $ly); }
		return;
	}

	# Sprungweite des naechsten Sprungs, also den Inhalt des Feldes, auf dem wir JETZT stehen, ermitteln
	my $lnextElement = $ly * ($xmax+1) + $lx; # Element == Element des Map-Arrays
	my $lnextsteps=$map[ $lnextElement ];
	
	# Steps mitloggen in die History
	$lhistory = $lhistory . "[" . $lnextsteps . "]";
	
	# Pruefen, welchen Wert DIESES Element der Map hat
	if (DEBUGLOG) { printf("Examining %s/%s, Element # %s (value: %s)\n", $lx, $ly, $lnextElement, $lnextsteps); }
	# Auf ein "F" getroffen?
	if ( $lnextsteps eq 'F' )
	{
		if (DEBUGLOG) 
		{ 
			printf("Found it! History: %s, Jumps # %s, Location: (%s/%s)\n", $lhistory, $ljumps, $lx, $ly);
			printf("Check how much Fs we walked over: \n");
		}
		my $f_count=FCountOnRoute($oldlx, $oldly, $lx, $ly); #, $lnextsteps);
		if (DEBUGLOG) { printf ("Walked over %s Fs.\n", $f_count); }
		if ($f_count == 1)
		{
			print ("Finished after a sum of $overalljumps jumps and $overalldeadends dead ends. Please check result on your paper version.\n");
			printf("History was: %s, Jumps: %s\n", $lhistory, $ljumps);
			die ("Poff!\n");
		}
		else
		{
			$overalldeadends++;
			if (DEBUGLOG) { printf("Dead end # %s: Too many Fs (%s) found on last jump. History: %s, Jumps # %s, Location: (%s/%s)\n", 
			$overalldeadends, $f_count, $lhistory, $ljumps, $lx, $ly); }
			return;
		}
	}
	elsif ( $lnextsteps eq 'N' )
	{
		#printf("Sackgasse (off-grid): %s -> %s\n", $lhistory, $ljumps);
		$overalldeadends++;
		if (DEBUGLOG) { printf("Dead end # %s (off-grid). History: %s, Jumps # %s, Location: (%s/%s)\n", $overalldeadends, $lhistory, $ljumps, $lx, $ly); }
		return;
	}



	#############
	# Nexter Step
	
	if (DEBUGLOG) { printf("The next jump will have %s steps.\n", $lnextsteps); }
	
	# Nun in alle Himmelsrichtungen springen
		# Oben
		jumpFromXY($lx, $ly-$lnextsteps, $lx, $ly, $lhistory, $ljumps); #, $lx, $ly);
		# Unten
		jumpFromXY($lx, $ly+$lnextsteps, $lx, $ly, $lhistory, $ljumps); #, $lx, $ly);
		# links
		jumpFromXY($lx-$lnextsteps, $ly, $lx, $ly, $lhistory, $ljumps); # #, $lx, $ly);
		# rechts
		jumpFromXY($lx+$lnextsteps, $ly, $lx, $ly, $lhistory, $ljumps); #, $lx, $ly);
		# links-oben
		jumpFromXY($lx-$lnextsteps, $ly-$lnextsteps, $lx, $ly, $lhistory, $ljumps); #, $lx, $ly);
		# links-unten
		jumpFromXY($lx-$lnextsteps, $ly+$lnextsteps, $lx, $ly, $lhistory, $ljumps); #, $lx, $ly);
		# rechts-unten
		jumpFromXY($lx+$lnextsteps, $ly+$lnextsteps, $lx, $ly, $lhistory, $ljumps); #, $lx, $ly);
		# rechts-oben
		jumpFromXY($lx+$lnextsteps, $ly-$lnextsteps, $lx, $ly, $lhistory, $ljumps); #, $lx, $ly);
}


sub FCountOnRoute
{
	my $l1x=shift; # Start - X
	my $l1y=shift; # Start - Y
	my $l2x=shift; # Ziel - X
	my $l2y=shift; # Ziel - Y
	#my $ljumps=shift; # Anzahl der Schritt von Start zu Ziel - könnte auch berechnet werden...
	
	# Den Weg "ablaufen", und checken, wann wir auf ein "F" stossen. Wenn wir zu frueh drauf stossen -> ungueltig! Es muss beim letzten Step sein!
	my $lxd=0;
	my $lyd=0;
	my $F_count=0;
	my $lsteps=@map[ $l1y * ($xmax+1) + $l1x ];
	if ( $l2x > $l1x ) # Horizontal nach rechts
	{
		$lxd = +1;
	}
	elsif ($l2x == $l1x) # Vertikale Bewegung
	{
		$lxd = 0;
	}
	else # Horizontal nach links
	{
		$lxd = -1;
	}
	if ( $l2y > $l1y ) # Vertikal nach unten
	{
		$lyd = +1;
	}
	elsif ($l1y == $l2y) # Horizontale Bewegung
	{
		$lyd = 0;
	}
	else # Vertikal nach oben
	{
		$lyd = -1;
	}

	
	my $lyi=0;
	my $lxi=0;
	my $li=0;
	for ($li=0, $lxi=$l1x, $lyi=$l1y; $li <= $lsteps; $li++, $lxi+=$lxd, $lyi+=$lyd)
	{
		my $nextElement = $lyi * ($xmax+1) + $lxi; # Element == Element des Map-Arrays
		if (DEBUGLOG) { printf("Walking over %s/%s, Element # %s (%s)\n", $lxi, $lyi, $nextElement, $map[ $nextElement ]); }
		if ( $map[ $nextElement ] eq 'F' )
		{
			$F_count++;
		}
	}
	
	# Durchlaufen...
	#	printf("Walking from (%s/%s) to (%s/%s) (X-Step: %s, Y-Step: %s)\n", $l1x, $l1y, $l2x, $l2y, $lxd, $lyd);
	#$l2x+=$lxd; # Damit die Schleife bis zum Ende durchlaueft
	#$l2y+=$lyd; # Damit die Schleife bis zum Ende durchlaueft
	#my $lyi=$l1y;
	#do # Y
	#{
	#	my $lxi=$l1x;
	#	do # X 
	#	{
	#		my $nextElement = $lyi * ($xmax+1) + $lxi; # Element == Element des Map-Arrays
	#		printf("Walking over %s/%s, Element # %s (%s)\n", $lxi, $lyi, $nextElement, $map[ $nextElement ]);
	#		if ( $map[ $nextElement ] eq 'F' )
	#		{
	#			$F_count++;
	#		}
	#		$lxi+=$lxd;
	#	} until ($lxi == $l2x);
	#	$lyi+=$lyd;
	#	} until ($lyi == $l2y);
	
	#	for (; $lyi != $l1y; $lyi+=$lyd)
	#{
	#	for (; $lxi != $l1x; $lxi+=$lxd)
	#	{
	#		my $nextElement = $lyi * ($xmax+1) + $lxi; # Element == Element des Map-Arrays
	#		printf("Walking over %s/%s, Element # %s (%s)\n", $lxi, $lyi, $nextElement, $map[ $nextElement ]);
	#		if ( $map[ $nextElement ] eq 'F' )
	#		{
	#			$F_count++;
	#		}
	#	}
	#}
	
	return($F_count);
}
















